This section details how to provide your own icons for the grid and style grid icons for your application requirements
Swapping the Provided Icon Set Copy Link
The grid provides several icon sets as theme parts. You can change the icon set on a theme using theme.withPart(iconSet).
Available icon sets are:
iconSetQuartz- our default icon seticonSetQuartz({strokeWidth: number})you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)iconSetQuartzLightandiconSetQuartzBoldpreset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
iconSetAlpine- the icon set used by the Alpine themeiconSetMaterial- the Material Design icon set (these are designed to be displayed at look best at 18, 24, 36 or 48px)
This example shows the Quartz theme with the Material icon set
import { iconSetMaterial, themeQuartz } from 'ag-grid-community';
const myTheme = themeQuartz
.withPart(iconSetMaterial)
// Material icons are designed to look best at 18, 24, 36 or 48px
.withParams({
iconSize: 18,
});import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
TextEditorModule,
createGrid,
enableDevValidations,
iconSetMaterial,
themeQuartz,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const myTheme = themeQuartz
.withPart(iconSetMaterial)
// Material icons are designed to look best at 18, 24, 36 or 48px
.withParams({
iconSize: 18,
});
const columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country", rowGroup: true },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
theme: myTheme,
rowData: null,
columnDefs: columnDefs,
defaultColDef: {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
},
sideBar: ["columns", "filters"],
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Styling Provided Icons Copy Link
You can change the colour of the provided icons using CSS, and add other CSS styles such as borders and backgrounds. Icons have CSS class names in the format ag-icon-{iconName}. Use browser developer tools to find the appropriate class.
Provided icons inherit the current text colour, so use the CSS color property to change their colour:
/* Set the column menu icon to red */
.ag-icon-menu-alt {
color: red;
}
/* Add a background to the row group icon */
.ag-icon-tree-closed,
.ag-icon-tree-open {
border-radius: 4px;
background-image: linear-gradient(to bottom, #66aec8, #aa74c6);
}import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
TextEditorModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
rowData: null,
columnDefs: columnDefs,
autoGroupColumnDef: {
headerName: "Country",
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
/* Set the column menu icon to red */
.ag-icon-menu-alt {
color: red;
}
/* Add a background to the row group icon */
.ag-icon-tree-closed,
.ag-icon-tree-open {
border-radius: 4px;
background-image: linear-gradient(to bottom, #66aec8, #aa74c6);
}
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Replacing Individual Icons Copy Link
The iconOverrides part can be used to change individual icons to an image, solid colour with image mask, or icon font character. It can be used multiple times in the same theme to mix different types of icon.
Overriding Icons with Images Copy Link
iconOverrides can replace icons with images using the following arguments:
| Parameter | Description |
|---|---|
type | image |
mask | If true, the icon shape is taken from the image and the colour from the grid foregroundColor parameter. This allows one icon to serve in both light and dark modes |
icons | A map of icon name to images. Values use image parameter syntax to accept image urls or svg source code. |
import { themeQuartz, iconOverrides } from 'ag-grid-community';
// create an icon override part
const mySvgIcons = iconOverrides({
type: 'image',
mask: true,
icons: {
// map of icon names to images
'filter': { url: 'https://examle.com/my-filter-icon.svg' },
'group': { svg: '<svg> ... svg source ...</svg>' },
}
});
// use it in a theme
const myTheme = themeQuartz.withPart(mySvgIcons); Replacing Icons with Icon Font Characters Copy Link
iconOverrides can replace icons with icon font glyphs or emoji using the following arguments:
| Parameter | Description |
|---|---|
type | font |
family | Optional, the name of the icon font family to use |
cssImports | Optional, an array CSS file URLs to import, can be used to load the CSS file that defines the icon font |
weight | Optional, e.g. bold. Some icon fonts such as fontawesome require a bold font weight. |
color | Optional CSS colour e.g. red. Can use colour parameter syntax to reference and mix other colour parameters. |
icons | A map of icon name to text data. If you're using an icon font, the correct character for each icon will be documented by your font. But you can use any text or emoji. |
import { themeQuartz, iconOverrides } from 'ag-grid-community';
// create an icon override part
const fontAwesomeIcons = iconOverrides({
type: 'font',
family: 'Font Awesome 5 Free',
cssImports: ['https://use.fontawesome.com/releases/v5.6.3/css/all.css'],
weight: 'bold', // Font Awesome requires bold font weight
icons: {
// use font codes documented by Font Awesome e.g. '\u{f062}' == arrow-up
asc: '\u{f062}',
desc: '\u{f063}',
},
})
// use it in a theme
const myTheme = themeQuartz.withPart(fontAwesomeIcons); Replacing Icons Example Copy Link
The following example combines the various ways of overriding icons:
- Sorting and grouping icons (coloured green) are replaced with characters from FontAwesome
- Group and Aggregation icons (coloured red) are replaced with characters from the Material Design Icons font
- The Columns icon (đïž) is replaced with an emoji
- The filter icon is replaced with a blue-coloured SVG image
- The column menu icon is replaced with an SVG image in mask mode. Although the image is blue, the icon uses the grid foreground colour and will change colour as appropriate for light or dark mode.
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
TextEditorModule,
createGrid,
enableDevValidations,
iconOverrides,
themeQuartz,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const myTheme = themeQuartz
.withPart(
iconOverrides({
type: "image",
icons: {
filter: {
url: "https://www.ag-grid.com/example-assets/svg-icons/filter.svg",
},
},
}),
)
.withPart(
iconOverrides({
type: "image",
mask: true,
icons: {
"menu-alt": {
url: "https://www.ag-grid.com/example-assets/svg-icons/menu-alt.svg",
},
},
}),
)
.withPart(
iconOverrides({
type: "font",
icons: {
columns: "đïž",
},
}),
)
.withPart(
iconOverrides({
cssImports: ["https://use.fontawesome.com/releases/v5.6.3/css/all.css"],
type: "font",
weight: "bold",
family: "Font Awesome 5 Free",
color: "green",
icons: {
asc: "\u{f062}",
desc: "\u{f063}",
"tree-closed": "\u{f105}",
"tree-indeterminate": "\u{f068}",
"tree-open": "\u{f107}",
},
}),
)
.withPart(
iconOverrides({
cssImports: [
"https://cdn.jsdelivr.net/npm/@mdi/font/css/materialdesignicons.css",
],
type: "font",
family: "Material Design Icons",
color: "red",
icons: {
group: "\u{F0328}",
aggregation: "\u{F02C3}",
},
}),
);
const columnDefs: ColDef[] = [
{ field: "country", sort: "asc", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
theme: myTheme,
rowData: null,
columnDefs: columnDefs,
defaultColDef: {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
},
autoGroupColumnDef: {
headerName: "Country",
},
sideBar: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Styling Icons Using CSS Copy Link
If you prefer to style your application using pure CSS, you can still change icons.
.ag-icon-group {
/* set a new image */
background: url('https://www.ag-grid.com/example-assets/svg-icons/group.svg');
/* hide the existing image-mask based icon from the provided theme */
color: transparent;
}import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
TextEditorModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const columnDefs: ColDef[] = [
{ field: "country", sort: "asc", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
rowData: null,
columnDefs: columnDefs,
defaultColDef: {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
},
autoGroupColumnDef: {
headerName: "Country",
},
sideBar: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
.ag-icon-aggregation::before {
background: url('https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg');
color: transparent;
}
.ag-icon-arrows {
background: url('https://www.ag-grid.com/example-assets/svg-icons/arrows.svg');
color: transparent;
}
.ag-icon-asc {
background: url('https://www.ag-grid.com/example-assets/svg-icons/asc.svg');
color: transparent;
}
.ag-icon-cancel {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cancel.svg');
color: transparent;
}
.ag-icon-chart {
background: url('https://www.ag-grid.com/example-assets/svg-icons/chart.svg');
color: transparent;
}
.ag-icon-color-picker {
background: url('https://www.ag-grid.com/example-assets/svg-icons/color-picker.svg');
color: transparent;
}
.ag-icon-column {
background: url('https://www.ag-grid.com/example-assets/svg-icons/column.svg');
color: transparent;
}
.ag-icon-columns {
background: url('https://www.ag-grid.com/example-assets/svg-icons/columns.svg');
color: transparent;
}
.ag-icon-contracted {
background: url('https://www.ag-grid.com/example-assets/svg-icons/contracted.svg');
color: transparent;
}
.ag-icon-copy {
background: url('https://www.ag-grid.com/example-assets/svg-icons/copy.svg');
color: transparent;
}
.ag-icon-cut {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cut.svg');
color: transparent;
}
.ag-icon-cross {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cross.svg');
color: transparent;
}
.ag-icon-cut {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cut.svg');
color: transparent;
}
.ag-icon-data {
background: url('https://www.ag-grid.com/example-assets/svg-icons/data.svg');
color: transparent;
}
.ag-icon-desc {
background: url('https://www.ag-grid.com/example-assets/svg-icons/desc.svg');
color: transparent;
}
.ag-icon-expanded {
background: url('https://www.ag-grid.com/example-assets/svg-icons/expanded.svg');
color: transparent;
}
.ag-icon-eye-slash {
background: url('https://www.ag-grid.com/example-assets/svg-icons/eye-slash.svg');
color: transparent;
}
.ag-icon-eye {
background: url('https://www.ag-grid.com/example-assets/svg-icons/eye.svg');
color: transparent;
}
.ag-icon-filter {
background: url('https://www.ag-grid.com/example-assets/svg-icons/filter.svg');
color: transparent;
}
.ag-icon-first {
background: url('https://www.ag-grid.com/example-assets/svg-icons/first.svg');
color: transparent;
}
.ag-icon-grip {
background: url('https://www.ag-grid.com/example-assets/svg-icons/grip.svg');
color: transparent;
}
.ag-icon-group {
background: url('https://www.ag-grid.com/example-assets/svg-icons/group.svg');
color: transparent;
}
.ag-icon-indeterminate {
background: url('https://www.ag-grid.com/example-assets/svg-icons/indeterminate.svg');
color: transparent;
}
.ag-icon-last {
background: url('https://www.ag-grid.com/example-assets/svg-icons/last.svg');
color: transparent;
}
.ag-icon-left {
background: url('https://www.ag-grid.com/example-assets/svg-icons/left.svg');
color: transparent;
}
.ag-icon-loading {
background: url('https://www.ag-grid.com/example-assets/svg-icons/loading.svg');
color: transparent;
}
.ag-icon-maximize {
background: url('https://www.ag-grid.com/example-assets/svg-icons/maximize.svg');
color: transparent;
}
.ag-icon-menu,
.ag-icon-menu-alt {
background: url('https://www.ag-grid.com/example-assets/svg-icons/menu.svg');
color: transparent;
}
.ag-icon-minimize {
background: url('https://www.ag-grid.com/example-assets/svg-icons/minimize.svg');
color: transparent;
}
.ag-icon-minus {
background: url('https://www.ag-grid.com/example-assets/svg-icons/minus.svg');
color: transparent;
}
.ag-icon-next {
background: url('https://www.ag-grid.com/example-assets/svg-icons/next.svg');
color: transparent;
}
.ag-icon-none {
background: url('https://www.ag-grid.com/example-assets/svg-icons/none.svg');
color: transparent;
}
.ag-icon-not-allowed {
background: url('https://www.ag-grid.com/example-assets/svg-icons/not-allowed.svg');
color: transparent;
}
.ag-icon-paste {
background: url('https://www.ag-grid.com/example-assets/svg-icons/paste.svg');
color: transparent;
}
.ag-icon-pin {
background: url('https://www.ag-grid.com/example-assets/svg-icons/pin.svg');
color: transparent;
}
.ag-icon-pivot {
background: url('https://www.ag-grid.com/example-assets/svg-icons/pivot.svg');
color: transparent;
}
.ag-icon-plus {
background: url('https://www.ag-grid.com/example-assets/svg-icons/plus.svg');
color: transparent;
}
.ag-icon-previous {
background: url('https://www.ag-grid.com/example-assets/svg-icons/previous.svg');
color: transparent;
}
.ag-icon-right {
background: url('https://www.ag-grid.com/example-assets/svg-icons/right.svg');
color: transparent;
}
.ag-icon-save {
background: url('https://www.ag-grid.com/example-assets/svg-icons/save.svg');
color: transparent;
}
.ag-icon-small-down {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-down.svg');
color: transparent;
}
.ag-icon-small-left {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-left.svg');
color: transparent;
}
.ag-icon-small-right {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-right.svg');
color: transparent;
}
.ag-icon-small-up {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-up.svg');
color: transparent;
}
.ag-icon-tick {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tick.svg');
color: transparent;
}
.ag-icon-tree-closed {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-closed.svg');
color: transparent;
}
.ag-icon-tree-indeterminate {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-indeterminate.svg');
color: transparent;
}
.ag-icon-tree-open {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-open.svg');
color: transparent;
}
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Provided Icons Copy Link
Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the pin icon will have the CSS class ag-icon-pin.
aggregation
arrows
asc
aasc
adesc
cancel
chart
chevron-up
chevron-down
chevron-left
chevron-right
color-picker
columns
contracted
copy
cut
cross
csv
desc
document
down
edit
excel
expanded
eye-slash
eye
filter
filter-add
first
fx
grip
group
last
left
linked
loading
maximize
menu
menu-alt
minimize
minus
next
none
not-allowed
paste
pin
pinned-bottom
pinned-top
pivot
plus
previous
right
save
search
small-down
small-left
small-right
small-up
tick
tree-closed
tree-indeterminate
tree-open
unlinked
up
values-as
Set the Icons Through gridOptions (JavaScript) Copy Link
You can pass an icons property either on the Grid Options to apply across the whole grid, or the Column Definition. If both are provided, icons specified at the column level will take priority.
The icons property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:
- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowDragModule,
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
RowGroupingModule,
SideBarModule,
ColumnMenuModule,
ContextMenuModule,
PivotModule,
]);
const myIcons = {
sortAscending: () => {
return "ASC";
},
sortDescending: () => {
return "DESC";
},
};
const columnDefs: ColDef[] = [
{
field: "athlete",
rowGroup: true,
hide: true,
},
{
field: "age",
width: 90,
enableValue: true,
icons: {
// not very useful, but demonstrates you can just have strings
sortAscending: "U",
sortDescending: "D",
},
},
{
field: "country",
width: 150,
rowGroupIndex: 0,
icons: {
sortAscending: '<i class="fa fa-sort-alpha-up"/>',
sortDescending: '<i class="fa fa-sort-alpha-down"/>',
},
},
{ field: "year", width: 90, enableRowGroup: true },
{ field: "date" },
{
field: "sport",
width: 110,
icons: myIcons,
},
{ field: "gold", width: 100 },
{ field: "silver", width: 100 },
{ field: "bronze", width: 100 },
{ field: "total", width: 100 },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
defaultColDef: {
width: 150,
filter: true,
floatingFilter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
},
columnDefs: columnDefs,
rowData: null,
sideBar: true,
autoGroupColumnDef: {
headerName: "Athlete",
field: "athlete",
rowDrag: true,
// use font awesome for first col, with numbers for sort
icons: {
menu: '<i class="fa fa-shower"/>',
menuAlt: '<i class="fa fa-shower"/>',
filter: '<i class="fa fa-long-arrow-alt-up"/>',
columns: '<i class="fa fa-snowflake"/>',
sortAscending: '<i class="fa fa-sort-alpha-up"/>',
sortDescending: '<i class="fa fa-sort-alpha-down"/>',
},
width: 300,
},
// override all the defaults with font awesome
icons: {
// use font awesome for menu icons
menu: '<i class="fa fa-bath" style="width: 10px"/>',
menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
filter: '<i class="fa fa-long-arrow-alt-down"/>',
columns: '<i class="fa fa-handshake"/>',
sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
// use some strings from group
groupExpanded:
'<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
groupContracted:
'<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
columnMovePin: '<i class="far fa-hand-rock"/>',
columnMoveAdd: '<i class="fa fa-plus-square"/>',
columnMoveHide: '<i class="fa fa-times"/>',
columnMoveMove: '<i class="fa fa-link"/>',
columnMoveLeft: '<i class="fa fa-arrow-left"/>',
columnMoveRight: '<i class="fa fa-arrow-right"/>',
columnMoveGroup: '<i class="fa fa-users"/>',
rowGroupPanel: '<i class="fa fa-university"/>',
pivotPanel: '<i class="fa fa-magic"/>',
valuePanel: '<i class="fa fa-magnet"/>',
menuPin: "P", // just showing letters, no graphic
menuValue: "V",
menuAddRowGroup: "A",
menuRemoveRowGroup: "R",
clipboardCopy: ">>",
clipboardCut: "<<",
clipboardPaste: ">>",
rowDrag: '<i class="fa fa-circle"/>',
columnDrag: '<i class="fa fa-square"/>',
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} In the following list, the name to use in the grid options is to the left, and on the right is default value CSS icon name as listed in the Provided Icons table below.
Icon Names Copy Link
This is a mapping of javascript name to CSS name for icons. When overriding icons using grid options, use the names on the left. When overriding icons in CSS or with iconOverrides, use the names on the right.
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed'
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open'
// column tool panel header expand/collapse all button, shown
// when some children are expanded and others are collapsed
columnSelectIndeterminate: 'tree-indeterminate'
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open'
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed'
// accordion indeterminate - shown when some children are expanded and
// others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate'
// shown on drag and drop image component icon while dragging
// column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over
// part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging
// columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of
// the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of
// the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging
// over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging
// over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging
// over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging
// over drop zone that doesn't support it, e.g.
// string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed'
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open'
// set filter tree list expand/collapse all button, shown when
// some children are expanded and
// others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate'
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column"
// sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range
// data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to
// range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// rotating spinner shown by the loading overlay
overlayLoading: 'loading'
// button to launch legacy column menu
menu: 'menu'
// button to launch new enterprise column menu
menuAlt: 'menu-alt'
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter'
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter add button in new filter tool panel
filterAdd: 'filterAdd'
// button to collapse filter card in new filter tool panel
filterCardCollapse: 'chevron-up'
// button to expand filter card in new filter tool panel
filterCardExpand: 'chevron-down'
// indicates filter card in new filter tool panel has edits
filterCardEditing: 'edit'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter'
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Ensure Column Visible" item in column tool panel context menu
ensureColumnVisible: 'column-arrow'
// calculated column header indicator
calculatedColumnsHeader: 'fx'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric
// columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// rotating spinner shown by the export overlay
overlayExporting: 'loading',
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down'
// open icon for rich select editor
richSelectOpen: 'small-down'
// remove for rich select editor pills
richSelectRemove: 'cancel'
// list items async values loading
richSelectLoading: 'loading'
// icon for sub menu item
subMenuOpen: 'small-right'
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left'
// separator between column 'pills' when you add multiple
// columns to the header drop zone
panelDelimiter: 'small-right'
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left'
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column is sorted absolute ascending
sortAbsoluteAscending: 'aasc'
// show on column header when column is sorted absolute descending
sortAbsoluteDescending: 'adesc'
// show on column header when column has no sort, only when
// enabled with colDef.unSortIcon=true
sortUnSort: 'none'
// Builder button in Advanced Filter
advancedFilterBuilder: 'group'
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip'
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed'
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up'
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down'
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus'
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus'
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down'
// icon to open charts menu
chartsMenu: 'menu-alt'
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart'
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings'
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus'
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous'
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next'
// download chart
chartsDownload: 'save'
// icon used in the find toolbar input and in filter search inputs
search: 'search'
// file input overlay
document: 'document'

This section details how to provide your own icons for the grid and style grid icons for your application requirements
Swapping the Provided Icon Set Copy Link
The grid provides several icon sets as theme parts. You can change the icon set on a theme using theme.withPart(iconSet).
Available icon sets are:
iconSetQuartz- our default icon seticonSetQuartz({strokeWidth: number})you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)iconSetQuartzLightandiconSetQuartzBoldpreset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
iconSetAlpine- the icon set used by the Alpine themeiconSetMaterial- the Material Design icon set (these are designed to be displayed at look best at 18, 24, 36 or 48px)
This example shows the Quartz theme with the Material icon set
import { iconSetMaterial, themeQuartz } from 'ag-grid-community';
const myTheme = themeQuartz
.withPart(iconSetMaterial)
// Material icons are designed to look best at 18, 24, 36 or 48px
.withParams({
iconSize: 18,
});import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
iconSetMaterial,
themeQuartz,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[theme]="theme"
[rowData]="rowData"
[defaultColDef]="defaultColDef"
[sideBar]="sideBar"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country", rowGroup: true },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
theme: Theme | "legacy" = myTheme;
defaultColDef: ColDef = {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
sideBar: SideBarDef | string | string[] | boolean | null = [
"columns",
"filters",
];
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
const myTheme = themeQuartz
.withPart(iconSetMaterial)
// Material icons are designed to look best at 18, 24, 36 or 48px
.withParams({
iconSize: 18,
});
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Styling Provided Icons Copy Link
You can change the colour of the provided icons using CSS, and add other CSS styles such as borders and backgrounds. Icons have CSS class names in the format ag-icon-{iconName}. Use browser developer tools to find the appropriate class.
Provided icons inherit the current text colour, so use the CSS color property to change their colour:
/* Set the column menu icon to red */
.ag-icon-menu-alt {
color: red;
}
/* Add a background to the row group icon */
.ag-icon-tree-closed,
.ag-icon-tree-open {
border-radius: 4px;
background-image: linear-gradient(to bottom, #66aec8, #aa74c6);
}import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[rowData]="rowData"
[autoGroupColumnDef]="autoGroupColumnDef"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "Country",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
/* Set the column menu icon to red */
.ag-icon-menu-alt {
color: red;
}
/* Add a background to the row group icon */
.ag-icon-tree-closed,
.ag-icon-tree-open {
border-radius: 4px;
background-image: linear-gradient(to bottom, #66aec8, #aa74c6);
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Replacing Individual Icons Copy Link
The iconOverrides part can be used to change individual icons to an image, solid colour with image mask, or icon font character. It can be used multiple times in the same theme to mix different types of icon.
Overriding Icons with Images Copy Link
iconOverrides can replace icons with images using the following arguments:
| Parameter | Description |
|---|---|
type | image |
mask | If true, the icon shape is taken from the image and the colour from the grid foregroundColor parameter. This allows one icon to serve in both light and dark modes |
icons | A map of icon name to images. Values use image parameter syntax to accept image urls or svg source code. |
import { themeQuartz, iconOverrides } from 'ag-grid-community';
// create an icon override part
const mySvgIcons = iconOverrides({
type: 'image',
mask: true,
icons: {
// map of icon names to images
'filter': { url: 'https://examle.com/my-filter-icon.svg' },
'group': { svg: '<svg> ... svg source ...</svg>' },
}
});
// use it in a theme
const myTheme = themeQuartz.withPart(mySvgIcons); Replacing Icons with Icon Font Characters Copy Link
iconOverrides can replace icons with icon font glyphs or emoji using the following arguments:
| Parameter | Description |
|---|---|
type | font |
family | Optional, the name of the icon font family to use |
cssImports | Optional, an array CSS file URLs to import, can be used to load the CSS file that defines the icon font |
weight | Optional, e.g. bold. Some icon fonts such as fontawesome require a bold font weight. |
color | Optional CSS colour e.g. red. Can use colour parameter syntax to reference and mix other colour parameters. |
icons | A map of icon name to text data. If you're using an icon font, the correct character for each icon will be documented by your font. But you can use any text or emoji. |
import { themeQuartz, iconOverrides } from 'ag-grid-community';
// create an icon override part
const fontAwesomeIcons = iconOverrides({
type: 'font',
family: 'Font Awesome 5 Free',
cssImports: ['https://use.fontawesome.com/releases/v5.6.3/css/all.css'],
weight: 'bold', // Font Awesome requires bold font weight
icons: {
// use font codes documented by Font Awesome e.g. '\u{f062}' == arrow-up
asc: '\u{f062}',
desc: '\u{f063}',
},
})
// use it in a theme
const myTheme = themeQuartz.withPart(fontAwesomeIcons); Replacing Icons Example Copy Link
The following example combines the various ways of overriding icons:
- Sorting and grouping icons (coloured green) are replaced with characters from FontAwesome
- Group and Aggregation icons (coloured red) are replaced with characters from the Material Design Icons font
- The Columns icon (đïž) is replaced with an emoji
- The filter icon is replaced with a blue-coloured SVG image
- The column menu icon is replaced with an SVG image in mask mode. Although the image is blue, the icon uses the grid foreground colour and will change colour as appropriate for light or dark mode.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
iconOverrides,
themeQuartz,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[theme]="theme"
[rowData]="rowData"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="true"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", sort: "asc", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
theme: Theme | "legacy" = myTheme;
defaultColDef: ColDef = {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "Country",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
const myTheme = themeQuartz
.withPart(
iconOverrides({
type: "image",
icons: {
filter: {
url: "https://www.ag-grid.com/example-assets/svg-icons/filter.svg",
},
},
}),
)
.withPart(
iconOverrides({
type: "image",
mask: true,
icons: {
"menu-alt": {
url: "https://www.ag-grid.com/example-assets/svg-icons/menu-alt.svg",
},
},
}),
)
.withPart(
iconOverrides({
type: "font",
icons: {
columns: "đïž",
},
}),
)
.withPart(
iconOverrides({
cssImports: ["https://use.fontawesome.com/releases/v5.6.3/css/all.css"],
type: "font",
weight: "bold",
family: "Font Awesome 5 Free",
color: "green",
icons: {
asc: "\u{f062}",
desc: "\u{f063}",
"tree-closed": "\u{f105}",
"tree-indeterminate": "\u{f068}",
"tree-open": "\u{f107}",
},
}),
)
.withPart(
iconOverrides({
cssImports: [
"https://cdn.jsdelivr.net/npm/@mdi/font/css/materialdesignicons.css",
],
type: "font",
family: "Material Design Icons",
color: "red",
icons: {
group: "\u{F0328}",
aggregation: "\u{F02C3}",
},
}),
);
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Styling Icons Using CSS Copy Link
If you prefer to style your application using pure CSS, you can still change icons.
.ag-icon-group {
/* set a new image */
background: url('https://www.ag-grid.com/example-assets/svg-icons/group.svg');
/* hide the existing image-mask based icon from the provided theme */
color: transparent;
}import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[rowData]="rowData"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="true"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", sort: "asc", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "Country",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.ag-icon-aggregation::before {
background: url('https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg');
color: transparent;
}
.ag-icon-arrows {
background: url('https://www.ag-grid.com/example-assets/svg-icons/arrows.svg');
color: transparent;
}
.ag-icon-asc {
background: url('https://www.ag-grid.com/example-assets/svg-icons/asc.svg');
color: transparent;
}
.ag-icon-cancel {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cancel.svg');
color: transparent;
}
.ag-icon-chart {
background: url('https://www.ag-grid.com/example-assets/svg-icons/chart.svg');
color: transparent;
}
.ag-icon-color-picker {
background: url('https://www.ag-grid.com/example-assets/svg-icons/color-picker.svg');
color: transparent;
}
.ag-icon-column {
background: url('https://www.ag-grid.com/example-assets/svg-icons/column.svg');
color: transparent;
}
.ag-icon-columns {
background: url('https://www.ag-grid.com/example-assets/svg-icons/columns.svg');
color: transparent;
}
.ag-icon-contracted {
background: url('https://www.ag-grid.com/example-assets/svg-icons/contracted.svg');
color: transparent;
}
.ag-icon-copy {
background: url('https://www.ag-grid.com/example-assets/svg-icons/copy.svg');
color: transparent;
}
.ag-icon-cut {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cut.svg');
color: transparent;
}
.ag-icon-cross {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cross.svg');
color: transparent;
}
.ag-icon-cut {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cut.svg');
color: transparent;
}
.ag-icon-data {
background: url('https://www.ag-grid.com/example-assets/svg-icons/data.svg');
color: transparent;
}
.ag-icon-desc {
background: url('https://www.ag-grid.com/example-assets/svg-icons/desc.svg');
color: transparent;
}
.ag-icon-expanded {
background: url('https://www.ag-grid.com/example-assets/svg-icons/expanded.svg');
color: transparent;
}
.ag-icon-eye-slash {
background: url('https://www.ag-grid.com/example-assets/svg-icons/eye-slash.svg');
color: transparent;
}
.ag-icon-eye {
background: url('https://www.ag-grid.com/example-assets/svg-icons/eye.svg');
color: transparent;
}
.ag-icon-filter {
background: url('https://www.ag-grid.com/example-assets/svg-icons/filter.svg');
color: transparent;
}
.ag-icon-first {
background: url('https://www.ag-grid.com/example-assets/svg-icons/first.svg');
color: transparent;
}
.ag-icon-grip {
background: url('https://www.ag-grid.com/example-assets/svg-icons/grip.svg');
color: transparent;
}
.ag-icon-group {
background: url('https://www.ag-grid.com/example-assets/svg-icons/group.svg');
color: transparent;
}
.ag-icon-indeterminate {
background: url('https://www.ag-grid.com/example-assets/svg-icons/indeterminate.svg');
color: transparent;
}
.ag-icon-last {
background: url('https://www.ag-grid.com/example-assets/svg-icons/last.svg');
color: transparent;
}
.ag-icon-left {
background: url('https://www.ag-grid.com/example-assets/svg-icons/left.svg');
color: transparent;
}
.ag-icon-loading {
background: url('https://www.ag-grid.com/example-assets/svg-icons/loading.svg');
color: transparent;
}
.ag-icon-maximize {
background: url('https://www.ag-grid.com/example-assets/svg-icons/maximize.svg');
color: transparent;
}
.ag-icon-menu,
.ag-icon-menu-alt {
background: url('https://www.ag-grid.com/example-assets/svg-icons/menu.svg');
color: transparent;
}
.ag-icon-minimize {
background: url('https://www.ag-grid.com/example-assets/svg-icons/minimize.svg');
color: transparent;
}
.ag-icon-minus {
background: url('https://www.ag-grid.com/example-assets/svg-icons/minus.svg');
color: transparent;
}
.ag-icon-next {
background: url('https://www.ag-grid.com/example-assets/svg-icons/next.svg');
color: transparent;
}
.ag-icon-none {
background: url('https://www.ag-grid.com/example-assets/svg-icons/none.svg');
color: transparent;
}
.ag-icon-not-allowed {
background: url('https://www.ag-grid.com/example-assets/svg-icons/not-allowed.svg');
color: transparent;
}
.ag-icon-paste {
background: url('https://www.ag-grid.com/example-assets/svg-icons/paste.svg');
color: transparent;
}
.ag-icon-pin {
background: url('https://www.ag-grid.com/example-assets/svg-icons/pin.svg');
color: transparent;
}
.ag-icon-pivot {
background: url('https://www.ag-grid.com/example-assets/svg-icons/pivot.svg');
color: transparent;
}
.ag-icon-plus {
background: url('https://www.ag-grid.com/example-assets/svg-icons/plus.svg');
color: transparent;
}
.ag-icon-previous {
background: url('https://www.ag-grid.com/example-assets/svg-icons/previous.svg');
color: transparent;
}
.ag-icon-right {
background: url('https://www.ag-grid.com/example-assets/svg-icons/right.svg');
color: transparent;
}
.ag-icon-save {
background: url('https://www.ag-grid.com/example-assets/svg-icons/save.svg');
color: transparent;
}
.ag-icon-small-down {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-down.svg');
color: transparent;
}
.ag-icon-small-left {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-left.svg');
color: transparent;
}
.ag-icon-small-right {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-right.svg');
color: transparent;
}
.ag-icon-small-up {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-up.svg');
color: transparent;
}
.ag-icon-tick {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tick.svg');
color: transparent;
}
.ag-icon-tree-closed {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-closed.svg');
color: transparent;
}
.ag-icon-tree-indeterminate {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-indeterminate.svg');
color: transparent;
}
.ag-icon-tree-open {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-open.svg');
color: transparent;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Provided Icons Copy Link
Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the pin icon will have the CSS class ag-icon-pin.
aggregation
arrows
asc
aasc
adesc
cancel
chart
chevron-up
chevron-down
chevron-left
chevron-right
color-picker
columns
contracted
copy
cut
cross
csv
desc
document
down
edit
excel
expanded
eye-slash
eye
filter
filter-add
first
fx
grip
group
last
left
linked
loading
maximize
menu
menu-alt
minimize
minus
next
none
not-allowed
paste
pin
pinned-bottom
pinned-top
pivot
plus
previous
right
save
search
small-down
small-left
small-right
small-up
tick
tree-closed
tree-indeterminate
tree-open
unlinked
up
values-as
Set the Icons Through gridOptions (JavaScript) Copy Link
You can pass an icons property either on the Grid Options to apply across the whole grid, or the Column Definition. If both are provided, icons specified at the column level will take priority.
The icons property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:
- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
Icons,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SideBarModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowDragModule,
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
RowGroupingModule,
SideBarModule,
ColumnMenuModule,
ContextMenuModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[sideBar]="true"
[autoGroupColumnDef]="autoGroupColumnDef"
[icons]="icons"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "athlete",
rowGroup: true,
hide: true,
},
{
field: "age",
width: 90,
enableValue: true,
icons: {
// not very useful, but demonstrates you can just have strings
sortAscending: "U",
sortDescending: "D",
},
},
{
field: "country",
width: 150,
rowGroupIndex: 0,
icons: {
sortAscending: '<i class="fa fa-sort-alpha-up"/>',
sortDescending: '<i class="fa fa-sort-alpha-down"/>',
},
},
{ field: "year", width: 90, enableRowGroup: true },
{ field: "date" },
{
field: "sport",
width: 110,
icons: myIcons,
},
{ field: "gold", width: 100 },
{ field: "silver", width: 100 },
{ field: "bronze", width: 100 },
{ field: "total", width: 100 },
];
defaultColDef: ColDef = {
width: 150,
filter: true,
floatingFilter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "Athlete",
field: "athlete",
rowDrag: true,
// use font awesome for first col, with numbers for sort
icons: {
menu: '<i class="fa fa-shower"/>',
menuAlt: '<i class="fa fa-shower"/>',
filter: '<i class="fa fa-long-arrow-alt-up"/>',
columns: '<i class="fa fa-snowflake"/>',
sortAscending: '<i class="fa fa-sort-alpha-up"/>',
sortDescending: '<i class="fa fa-sort-alpha-down"/>',
},
width: 300,
};
icons: Icons = {
// use font awesome for menu icons
menu: '<i class="fa fa-bath" style="width: 10px"/>',
menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
filter: '<i class="fa fa-long-arrow-alt-down"/>',
columns: '<i class="fa fa-handshake"/>',
sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
// use some strings from group
groupExpanded:
'<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
groupContracted:
'<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
columnMovePin: '<i class="far fa-hand-rock"/>',
columnMoveAdd: '<i class="fa fa-plus-square"/>',
columnMoveHide: '<i class="fa fa-times"/>',
columnMoveMove: '<i class="fa fa-link"/>',
columnMoveLeft: '<i class="fa fa-arrow-left"/>',
columnMoveRight: '<i class="fa fa-arrow-right"/>',
columnMoveGroup: '<i class="fa fa-users"/>',
rowGroupPanel: '<i class="fa fa-university"/>',
pivotPanel: '<i class="fa fa-magic"/>',
valuePanel: '<i class="fa fa-magnet"/>',
menuPin: "P", // just showing letters, no graphic
menuValue: "V",
menuAddRowGroup: "A",
menuRemoveRowGroup: "R",
clipboardCopy: ">>",
clipboardCut: "<<",
clipboardPaste: ">>",
rowDrag: '<i class="fa fa-circle"/>',
columnDrag: '<i class="fa fa-square"/>',
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
const myIcons = {
sortAscending: () => {
return "ASC";
},
sortDescending: () => {
return "DESC";
},
};
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} In the following list, the name to use in the grid options is to the left, and on the right is default value CSS icon name as listed in the Provided Icons table below.
Icon Names Copy Link
This is a mapping of javascript name to CSS name for icons. When overriding icons using grid options, use the names on the left. When overriding icons in CSS or with iconOverrides, use the names on the right.
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed'
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open'
// column tool panel header expand/collapse all button, shown
// when some children are expanded and others are collapsed
columnSelectIndeterminate: 'tree-indeterminate'
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open'
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed'
// accordion indeterminate - shown when some children are expanded and
// others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate'
// shown on drag and drop image component icon while dragging
// column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over
// part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging
// columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of
// the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of
// the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging
// over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging
// over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging
// over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging
// over drop zone that doesn't support it, e.g.
// string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed'
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open'
// set filter tree list expand/collapse all button, shown when
// some children are expanded and
// others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate'
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column"
// sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range
// data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to
// range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// rotating spinner shown by the loading overlay
overlayLoading: 'loading'
// button to launch legacy column menu
menu: 'menu'
// button to launch new enterprise column menu
menuAlt: 'menu-alt'
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter'
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter add button in new filter tool panel
filterAdd: 'filterAdd'
// button to collapse filter card in new filter tool panel
filterCardCollapse: 'chevron-up'
// button to expand filter card in new filter tool panel
filterCardExpand: 'chevron-down'
// indicates filter card in new filter tool panel has edits
filterCardEditing: 'edit'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter'
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Ensure Column Visible" item in column tool panel context menu
ensureColumnVisible: 'column-arrow'
// calculated column header indicator
calculatedColumnsHeader: 'fx'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric
// columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// rotating spinner shown by the export overlay
overlayExporting: 'loading',
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down'
// open icon for rich select editor
richSelectOpen: 'small-down'
// remove for rich select editor pills
richSelectRemove: 'cancel'
// list items async values loading
richSelectLoading: 'loading'
// icon for sub menu item
subMenuOpen: 'small-right'
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left'
// separator between column 'pills' when you add multiple
// columns to the header drop zone
panelDelimiter: 'small-right'
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left'
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column is sorted absolute ascending
sortAbsoluteAscending: 'aasc'
// show on column header when column is sorted absolute descending
sortAbsoluteDescending: 'adesc'
// show on column header when column has no sort, only when
// enabled with colDef.unSortIcon=true
sortUnSort: 'none'
// Builder button in Advanced Filter
advancedFilterBuilder: 'group'
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip'
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed'
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up'
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down'
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus'
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus'
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down'
// icon to open charts menu
chartsMenu: 'menu-alt'
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart'
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings'
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus'
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous'
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next'
// download chart
chartsDownload: 'save'
// icon used in the find toolbar input and in filter search inputs
search: 'search'
// file input overlay
document: 'document'

This section details how to provide your own icons for the grid and style grid icons for your application requirements
Swapping the Provided Icon Set Copy Link
The grid provides several icon sets as theme parts. You can change the icon set on a theme using theme.withPart(iconSet).
Available icon sets are:
iconSetQuartz- our default icon seticonSetQuartz({strokeWidth: number})you can call iconSetQuartz as a function to provide a custom stroke width in pixels (the default is 1.5)iconSetQuartzLightandiconSetQuartzBoldpreset lighter and bolder versions of the Quartz icons with 1px and 2px stroke widths respectively.
iconSetAlpine- the icon set used by the Alpine themeiconSetMaterial- the Material Design icon set (these are designed to be displayed at look best at 18, 24, 36 or 48px)
This example shows the Quartz theme with the Material icon set
import { iconSetMaterial, themeQuartz } from 'ag-grid-community';
const myTheme = themeQuartz
.withPart(iconSetMaterial)
// Material icons are designed to look best at 18, 24, 36 or 48px
.withParams({
iconSize: 18,
});import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
iconSetMaterial,
themeQuartz,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const myTheme = themeQuartz
.withPart(iconSetMaterial)
// Material icons are designed to look best at 18, 24, 36 or 48px
.withParams({
iconSize: 18,
});
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:theme="theme"
:rowData="rowData"
:defaultColDef="defaultColDef"
:sideBar="sideBar"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country", rowGroup: true },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const theme = ref<Theme | "legacy">(myTheme);
const defaultColDef = ref<ColDef>({
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>([
"columns",
"filters",
]);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
theme,
rowData,
defaultColDef,
sideBar,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Styling Provided Icons Copy Link
You can change the colour of the provided icons using CSS, and add other CSS styles such as borders and backgrounds. Icons have CSS class names in the format ag-icon-{iconName}. Use browser developer tools to find the appropriate class.
Provided icons inherit the current text colour, so use the CSS color property to change their colour:
/* Set the column menu icon to red */
.ag-icon-menu-alt {
color: red;
}
/* Add a background to the row group icon */
.ag-icon-tree-closed,
.ag-icon-tree-open {
border-radius: 4px;
background-image: linear-gradient(to bottom, #66aec8, #aa74c6);
}import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:rowData="rowData"
:autoGroupColumnDef="autoGroupColumnDef"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "Country",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
rowData,
autoGroupColumnDef,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
/* Set the column menu icon to red */
.ag-icon-menu-alt {
color: red;
}
/* Add a background to the row group icon */
.ag-icon-tree-closed,
.ag-icon-tree-open {
border-radius: 4px;
background-image: linear-gradient(to bottom, #66aec8, #aa74c6);
}
Replacing Individual Icons Copy Link
The iconOverrides part can be used to change individual icons to an image, solid colour with image mask, or icon font character. It can be used multiple times in the same theme to mix different types of icon.
Overriding Icons with Images Copy Link
iconOverrides can replace icons with images using the following arguments:
| Parameter | Description |
|---|---|
type | image |
mask | If true, the icon shape is taken from the image and the colour from the grid foregroundColor parameter. This allows one icon to serve in both light and dark modes |
icons | A map of icon name to images. Values use image parameter syntax to accept image urls or svg source code. |
import { themeQuartz, iconOverrides } from 'ag-grid-community';
// create an icon override part
const mySvgIcons = iconOverrides({
type: 'image',
mask: true,
icons: {
// map of icon names to images
'filter': { url: 'https://examle.com/my-filter-icon.svg' },
'group': { svg: '<svg> ... svg source ...</svg>' },
}
});
// use it in a theme
const myTheme = themeQuartz.withPart(mySvgIcons); Replacing Icons with Icon Font Characters Copy Link
iconOverrides can replace icons with icon font glyphs or emoji using the following arguments:
| Parameter | Description |
|---|---|
type | font |
family | Optional, the name of the icon font family to use |
cssImports | Optional, an array CSS file URLs to import, can be used to load the CSS file that defines the icon font |
weight | Optional, e.g. bold. Some icon fonts such as fontawesome require a bold font weight. |
color | Optional CSS colour e.g. red. Can use colour parameter syntax to reference and mix other colour parameters. |
icons | A map of icon name to text data. If you're using an icon font, the correct character for each icon will be documented by your font. But you can use any text or emoji. |
import { themeQuartz, iconOverrides } from 'ag-grid-community';
// create an icon override part
const fontAwesomeIcons = iconOverrides({
type: 'font',
family: 'Font Awesome 5 Free',
cssImports: ['https://use.fontawesome.com/releases/v5.6.3/css/all.css'],
weight: 'bold', // Font Awesome requires bold font weight
icons: {
// use font codes documented by Font Awesome e.g. '\u{f062}' == arrow-up
asc: '\u{f062}',
desc: '\u{f063}',
},
})
// use it in a theme
const myTheme = themeQuartz.withPart(fontAwesomeIcons); Replacing Icons Example Copy Link
The following example combines the various ways of overriding icons:
- Sorting and grouping icons (coloured green) are replaced with characters from FontAwesome
- Group and Aggregation icons (coloured red) are replaced with characters from the Material Design Icons font
- The Columns icon (đïž) is replaced with an emoji
- The filter icon is replaced with a blue-coloured SVG image
- The column menu icon is replaced with an SVG image in mask mode. Although the image is blue, the icon uses the grid foreground colour and will change colour as appropriate for light or dark mode.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
iconOverrides,
themeQuartz,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const myTheme = themeQuartz
.withPart(
iconOverrides({
type: "image",
icons: {
filter: {
url: "https://www.ag-grid.com/example-assets/svg-icons/filter.svg",
},
},
}),
)
.withPart(
iconOverrides({
type: "image",
mask: true,
icons: {
"menu-alt": {
url: "https://www.ag-grid.com/example-assets/svg-icons/menu-alt.svg",
},
},
}),
)
.withPart(
iconOverrides({
type: "font",
icons: {
columns: "đïž",
},
}),
)
.withPart(
iconOverrides({
cssImports: ["https://use.fontawesome.com/releases/v5.6.3/css/all.css"],
type: "font",
weight: "bold",
family: "Font Awesome 5 Free",
color: "green",
icons: {
asc: "\u{f062}",
desc: "\u{f063}",
"tree-closed": "\u{f105}",
"tree-indeterminate": "\u{f068}",
"tree-open": "\u{f107}",
},
}),
)
.withPart(
iconOverrides({
cssImports: [
"https://cdn.jsdelivr.net/npm/@mdi/font/css/materialdesignicons.css",
],
type: "font",
family: "Material Design Icons",
color: "red",
icons: {
group: "\u{F0328}",
aggregation: "\u{F02C3}",
},
}),
);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:theme="theme"
:rowData="rowData"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="true"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", sort: "asc", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const theme = ref<Theme | "legacy">(myTheme);
const defaultColDef = ref<ColDef>({
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "Country",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
theme,
rowData,
defaultColDef,
autoGroupColumnDef,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Styling Icons Using CSS Copy Link
If you prefer to style your application using pure CSS, you can still change icons.
.ag-icon-group {
/* set a new image */
background: url('https://www.ag-grid.com/example-assets/svg-icons/group.svg');
/* hide the existing image-mask based icon from the provided theme */
color: transparent;
}import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:rowData="rowData"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="true"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", sort: "asc", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "Country",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
rowData,
defaultColDef,
autoGroupColumnDef,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-icon-aggregation::before {
background: url('https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg');
color: transparent;
}
.ag-icon-arrows {
background: url('https://www.ag-grid.com/example-assets/svg-icons/arrows.svg');
color: transparent;
}
.ag-icon-asc {
background: url('https://www.ag-grid.com/example-assets/svg-icons/asc.svg');
color: transparent;
}
.ag-icon-cancel {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cancel.svg');
color: transparent;
}
.ag-icon-chart {
background: url('https://www.ag-grid.com/example-assets/svg-icons/chart.svg');
color: transparent;
}
.ag-icon-color-picker {
background: url('https://www.ag-grid.com/example-assets/svg-icons/color-picker.svg');
color: transparent;
}
.ag-icon-column {
background: url('https://www.ag-grid.com/example-assets/svg-icons/column.svg');
color: transparent;
}
.ag-icon-columns {
background: url('https://www.ag-grid.com/example-assets/svg-icons/columns.svg');
color: transparent;
}
.ag-icon-contracted {
background: url('https://www.ag-grid.com/example-assets/svg-icons/contracted.svg');
color: transparent;
}
.ag-icon-copy {
background: url('https://www.ag-grid.com/example-assets/svg-icons/copy.svg');
color: transparent;
}
.ag-icon-cut {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cut.svg');
color: transparent;
}
.ag-icon-cross {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cross.svg');
color: transparent;
}
.ag-icon-cut {
background: url('https://www.ag-grid.com/example-assets/svg-icons/cut.svg');
color: transparent;
}
.ag-icon-data {
background: url('https://www.ag-grid.com/example-assets/svg-icons/data.svg');
color: transparent;
}
.ag-icon-desc {
background: url('https://www.ag-grid.com/example-assets/svg-icons/desc.svg');
color: transparent;
}
.ag-icon-expanded {
background: url('https://www.ag-grid.com/example-assets/svg-icons/expanded.svg');
color: transparent;
}
.ag-icon-eye-slash {
background: url('https://www.ag-grid.com/example-assets/svg-icons/eye-slash.svg');
color: transparent;
}
.ag-icon-eye {
background: url('https://www.ag-grid.com/example-assets/svg-icons/eye.svg');
color: transparent;
}
.ag-icon-filter {
background: url('https://www.ag-grid.com/example-assets/svg-icons/filter.svg');
color: transparent;
}
.ag-icon-first {
background: url('https://www.ag-grid.com/example-assets/svg-icons/first.svg');
color: transparent;
}
.ag-icon-grip {
background: url('https://www.ag-grid.com/example-assets/svg-icons/grip.svg');
color: transparent;
}
.ag-icon-group {
background: url('https://www.ag-grid.com/example-assets/svg-icons/group.svg');
color: transparent;
}
.ag-icon-indeterminate {
background: url('https://www.ag-grid.com/example-assets/svg-icons/indeterminate.svg');
color: transparent;
}
.ag-icon-last {
background: url('https://www.ag-grid.com/example-assets/svg-icons/last.svg');
color: transparent;
}
.ag-icon-left {
background: url('https://www.ag-grid.com/example-assets/svg-icons/left.svg');
color: transparent;
}
.ag-icon-loading {
background: url('https://www.ag-grid.com/example-assets/svg-icons/loading.svg');
color: transparent;
}
.ag-icon-maximize {
background: url('https://www.ag-grid.com/example-assets/svg-icons/maximize.svg');
color: transparent;
}
.ag-icon-menu,
.ag-icon-menu-alt {
background: url('https://www.ag-grid.com/example-assets/svg-icons/menu.svg');
color: transparent;
}
.ag-icon-minimize {
background: url('https://www.ag-grid.com/example-assets/svg-icons/minimize.svg');
color: transparent;
}
.ag-icon-minus {
background: url('https://www.ag-grid.com/example-assets/svg-icons/minus.svg');
color: transparent;
}
.ag-icon-next {
background: url('https://www.ag-grid.com/example-assets/svg-icons/next.svg');
color: transparent;
}
.ag-icon-none {
background: url('https://www.ag-grid.com/example-assets/svg-icons/none.svg');
color: transparent;
}
.ag-icon-not-allowed {
background: url('https://www.ag-grid.com/example-assets/svg-icons/not-allowed.svg');
color: transparent;
}
.ag-icon-paste {
background: url('https://www.ag-grid.com/example-assets/svg-icons/paste.svg');
color: transparent;
}
.ag-icon-pin {
background: url('https://www.ag-grid.com/example-assets/svg-icons/pin.svg');
color: transparent;
}
.ag-icon-pivot {
background: url('https://www.ag-grid.com/example-assets/svg-icons/pivot.svg');
color: transparent;
}
.ag-icon-plus {
background: url('https://www.ag-grid.com/example-assets/svg-icons/plus.svg');
color: transparent;
}
.ag-icon-previous {
background: url('https://www.ag-grid.com/example-assets/svg-icons/previous.svg');
color: transparent;
}
.ag-icon-right {
background: url('https://www.ag-grid.com/example-assets/svg-icons/right.svg');
color: transparent;
}
.ag-icon-save {
background: url('https://www.ag-grid.com/example-assets/svg-icons/save.svg');
color: transparent;
}
.ag-icon-small-down {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-down.svg');
color: transparent;
}
.ag-icon-small-left {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-left.svg');
color: transparent;
}
.ag-icon-small-right {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-right.svg');
color: transparent;
}
.ag-icon-small-up {
background: url('https://www.ag-grid.com/example-assets/svg-icons/small-up.svg');
color: transparent;
}
.ag-icon-tick {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tick.svg');
color: transparent;
}
.ag-icon-tree-closed {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-closed.svg');
color: transparent;
}
.ag-icon-tree-indeterminate {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-indeterminate.svg');
color: transparent;
}
.ag-icon-tree-open {
background: url('https://www.ag-grid.com/example-assets/svg-icons/tree-open.svg');
color: transparent;
}
Provided Icons Copy Link
Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the pin icon will have the CSS class ag-icon-pin.
aggregation
arrows
asc
aasc
adesc
cancel
chart
chevron-up
chevron-down
chevron-left
chevron-right
color-picker
columns
contracted
copy
cut
cross
csv
desc
document
down
edit
excel
expanded
eye-slash
eye
filter
filter-add
first
fx
grip
group
last
left
linked
loading
maximize
menu
menu-alt
minimize
minus
next
none
not-allowed
paste
pin
pinned-bottom
pinned-top
pivot
plus
previous
right
save
search
small-down
small-left
small-right
small-up
tick
tree-closed
tree-indeterminate
tree-open
unlinked
up
values-as
Set the Icons Through gridOptions (JavaScript) Copy Link
You can pass an icons property either on the Grid Options to apply across the whole grid, or the Column Definition. If both are provided, icons specified at the column level will take priority.
The icons property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:
- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
Icons,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowDragModule,
TextFilterModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
RowGroupingModule,
SideBarModule,
ColumnMenuModule,
ContextMenuModule,
PivotModule,
]);
const myIcons = {
sortAscending: () => {
return "ASC";
},
sortDescending: () => {
return "DESC";
},
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:sideBar="true"
:autoGroupColumnDef="autoGroupColumnDef"
:icons="icons"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
rowGroup: true,
hide: true,
},
{
field: "age",
width: 90,
enableValue: true,
icons: {
// not very useful, but demonstrates you can just have strings
sortAscending: "U",
sortDescending: "D",
},
},
{
field: "country",
width: 150,
rowGroupIndex: 0,
icons: {
sortAscending: '<i class="fa fa-sort-alpha-up"/>',
sortDescending: '<i class="fa fa-sort-alpha-down"/>',
},
},
{ field: "year", width: 90, enableRowGroup: true },
{ field: "date" },
{
field: "sport",
width: 110,
icons: myIcons,
},
{ field: "gold", width: 100 },
{ field: "silver", width: 100 },
{ field: "bronze", width: 100 },
{ field: "total", width: 100 },
]);
const defaultColDef = ref<ColDef>({
width: 150,
filter: true,
floatingFilter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "Athlete",
field: "athlete",
rowDrag: true,
// use font awesome for first col, with numbers for sort
icons: {
menu: '<i class="fa fa-shower"/>',
menuAlt: '<i class="fa fa-shower"/>',
filter: '<i class="fa fa-long-arrow-alt-up"/>',
columns: '<i class="fa fa-snowflake"/>',
sortAscending: '<i class="fa fa-sort-alpha-up"/>',
sortDescending: '<i class="fa fa-sort-alpha-down"/>',
},
width: 300,
});
const icons = ref<Icons>({
// use font awesome for menu icons
menu: '<i class="fa fa-bath" style="width: 10px"/>',
menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
filter: '<i class="fa fa-long-arrow-alt-down"/>',
columns: '<i class="fa fa-handshake"/>',
sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
// use some strings from group
groupExpanded:
'<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
groupContracted:
'<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
columnMovePin: '<i class="far fa-hand-rock"/>',
columnMoveAdd: '<i class="fa fa-plus-square"/>',
columnMoveHide: '<i class="fa fa-times"/>',
columnMoveMove: '<i class="fa fa-link"/>',
columnMoveLeft: '<i class="fa fa-arrow-left"/>',
columnMoveRight: '<i class="fa fa-arrow-right"/>',
columnMoveGroup: '<i class="fa fa-users"/>',
rowGroupPanel: '<i class="fa fa-university"/>',
pivotPanel: '<i class="fa fa-magic"/>',
valuePanel: '<i class="fa fa-magnet"/>',
menuPin: "P", // just showing letters, no graphic
menuValue: "V",
menuAddRowGroup: "A",
menuRemoveRowGroup: "R",
clipboardCopy: ">>",
clipboardCut: "<<",
clipboardPaste: ">>",
rowDrag: '<i class="fa fa-circle"/>',
columnDrag: '<i class="fa fa-square"/>',
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
autoGroupColumnDef,
icons,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
In the following list, the name to use in the grid options is to the left, and on the right is default value CSS icon name as listed in the Provided Icons table below.
Icon Names Copy Link
This is a mapping of javascript name to CSS name for icons. When overriding icons using grid options, use the names on the left. When overriding icons in CSS or with iconOverrides, use the names on the right.
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed'
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open'
// column tool panel header expand/collapse all button, shown
// when some children are expanded and others are collapsed
columnSelectIndeterminate: 'tree-indeterminate'
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open'
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed'
// accordion indeterminate - shown when some children are expanded and
// others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate'
// shown on drag and drop image component icon while dragging
// column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over
// part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging
// columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of
// the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of
// the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging
// over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging
// over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging
// over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging
// over drop zone that doesn't support it, e.g.
// string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed'
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open'
// set filter tree list expand/collapse all button, shown when
// some children are expanded and
// others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate'
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column"
// sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range
// data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to
// range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// rotating spinner shown by the loading overlay
overlayLoading: 'loading'
// button to launch legacy column menu
menu: 'menu'
// button to launch new enterprise column menu
menuAlt: 'menu-alt'
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter'
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter add button in new filter tool panel
filterAdd: 'filterAdd'
// button to collapse filter card in new filter tool panel
filterCardCollapse: 'chevron-up'
// button to expand filter card in new filter tool panel
filterCardExpand: 'chevron-down'
// indicates filter card in new filter tool panel has edits
filterCardEditing: 'edit'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter'
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Ensure Column Visible" item in column tool panel context menu
ensureColumnVisible: 'column-arrow'
// calculated column header indicator
calculatedColumnsHeader: 'fx'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric
// columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// rotating spinner shown by the export overlay
overlayExporting: 'loading',
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down'
// open icon for rich select editor
richSelectOpen: 'small-down'
// remove for rich select editor pills
richSelectRemove: 'cancel'
// list items async values loading
richSelectLoading: 'loading'
// icon for sub menu item
subMenuOpen: 'small-right'
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left'
// separator between column 'pills' when you add multiple
// columns to the header drop zone
panelDelimiter: 'small-right'
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left'
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column is sorted absolute ascending
sortAbsoluteAscending: 'aasc'
// show on column header when column is sorted absolute descending
sortAbsoluteDescending: 'adesc'
// show on column header when column has no sort, only when
// enabled with colDef.unSortIcon=true
sortUnSort: 'none'
// Builder button in Advanced Filter
advancedFilterBuilder: 'group'
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip'
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed'
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up'
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down'
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus'
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus'
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down'
// icon to open charts menu
chartsMenu: 'menu-alt'
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart'
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings'
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus'
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous'
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next'
// download chart
chartsDownload: 'save'
// icon used in the find toolbar input and in filter search inputs
search: 'search'
// file input overlay
document: 'document'